#pragma once

#include "util/simpleobject/AgString.h"
#include <boost/thread/thread.hpp>

class AgThread
{
private:
    boost::shared_ptr<boost::thread> th_;

protected:
    virtual void run() = 0;

public:
    AgThread();
    virtual ~AgThread();
    virtual void start();
    void waitForFinished();
};
